require 'sketchup.rb'
require 'extensions.rb'

module CURIC
  module Gesture
    PLUGIN = self
    PLUGIN_NAMESPACE  = 'Curic'.freeze
    PLUGIN_ID         = 'Gesture'.freeze
    PLUGIN_NAME       = "#{PLUGIN_NAMESPACE} #{PLUGIN_ID}".freeze
    PLUGIN_VERSION    = '1.3.0'.freeze

    FILENAMESPACE = File.basename(__FILE__, '.*')
    PATH_ROOT     = File.dirname(__FILE__).freeze
    PATH          = File.join(PATH_ROOT, FILENAMESPACE).freeze

    Sketchup.require "#{PATH}/load_rubyencoder_helper"

    unless file_loaded?(__FILE__)
      ex = SketchupExtension.new(PLUGIN_NAME, "#{PATH}/loader")
      ex.version     = PLUGIN_VERSION
      ex.copyright   = 'Curic © 2023-2026'
      ex.creator     = 'Vo Quoc Hai (curic4su@gmail.com)'
      ex.description = 'Allows create mouse gestures and assign corresponding commands to them with multiple contexts.'
      Sketchup.register_extension(ex, true)
      PLUGIN_EX = ex
    end
  end
end
file_loaded(__FILE__)
