Vue.component("command", {
  model: {
    prop: "command",
    event: "click",
  },
  props: {
    command: {
      type: Object,
    },
    vertical: {
      type: Boolean,
      default: false,
    }
  },
  template: `
  <el-card shadow="never" class="item-container" :body-style="{ padding: '2px' }">
    <div class="command-item" @click="click()">
      <div class="command-layout" :class="commandClass">
        <div class="command-icon" >
          <template v-if="command.thumbnail">
            <el-image :src="command.thumbnail" class="command-icon-image" @load="$root.loadIcon(command, $event)">
              <div slot="error" class="image-slot">
                <el-image src="../css/images/tb_unknown.png"></el-image>
              </div>
            </el-image>
          </template>
        </div>
        
        <div class="command-info" :title="command.menu_text" :class="{'inline-command': !vertical}">
          <div class="item-name">
            <span>{{command.menu_text}}</span>
            <template v-if="command.menu_text != command.tooltip">
              <div class="command-tooltip status-text" :class="{'inline-tooltip': !vertical}"> {{command.tooltip}}</div>
            </template>
          </div>
          <div class="command-category" v-if="!vertical">
            <template  v-if="command.toolbar"><span class="name-text">Toolbar: {{command.toolbar}}</span></template>
            <template  v-else-if="command.extension"><span class="name-text">Extension: {{command.extension}}</span></template>
          </div>
        </div>
      </div>
    </div>
  </el-card>
  `,
  methods: {
    click(){
      this.$emit('click', this.command);
    }
  },
  watch: {
    // 
  },
  computed: {
    commandClass(){
      return {
        'command-vertical': this.vertical,
        'command-horizontal': !this.vertical,
      } 
    }
  },
  mounted: function (){
    // var self = this;
  },
  created: function(){
    // console.log('command create', this.command.menu_text)
  }
});