// ELEMENT.locale(ELEMENT.lang.en)
// Vue app

var app = new Vue({
  el: '#app',
  data: function() {
    return {
      search: '',
      gestures: {},
      contexts: [
        {
          name: 'all',
          label: 'Global',
        },
        {
          name: 'activeTool',
          label: 'Active Tool',
        },
      ],
      activeContextName: 'all',
      directions: [
        {
          name: 'right',
          class: 'right',
          label: 'Right',
          value: null,
          fonticon: 'fa fa-arrow-right',
          icon: 'right.svg',
        },
        {
          name: 'down_right',
          class: 'down-right',
          label: 'Down Right',
          value: null,
          fonticon: 'fa fa-arrow-down',
          icon: 'down-right.svg',
        },
        {
          name: 'down',
          class: 'down',
          label: 'Down',
          value: null,
          fonticon: 'fa fa-arrow-down',
          icon: 'down.svg',
        },
        {
          name: 'down_left',
          class: 'down-left',
          label: 'Down Left',
          value: null,
          fonticon: 'fa fa-arrow-up fa-rotate-180',
          icon: 'down-left.svg',
        },
        {
          name: 'left',
          class: 'left',
          label: 'Left',
          value: null,
          fonticon: 'fa fa-arrow-left',
          icon: 'left.svg',
        },
        
        {
          name: 'up_left',
          class: 'up-left',
          label: 'Up Left',
          value: null,
          fonticon: 'fa fa-arrow-up fa-flip-horizontal',
          icon: 'up-left.svg',
        },
        {
          name: 'up',
          class: 'up',
          label: 'Up',
          value: null,
          fonticon: 'fa fa-arrow-up',
          icon: 'up.svg',
        },
        {
          name: 'up_right',
          class: 'up-right',
          label: 'Up Right',
          value: null,
          fonticon: 'fa fa-arrow-up',
          icon: 'up-right.svg',
        },
      ],
      two_directions: [
        {
          name: 'up_then_left',
          class: 'up-then-left',
          label: 'Up Then Left',
          value: null,
          icon: 'up-then-left.svg',
        },
        {
          name: 'up_then_right',
          class: 'up-then-right',
          label: 'Up Then Right',
          value: null,
          icon: 'up-then-right.svg',
        },
        {
          name: 'down_then_right',
          class: 'down-then-right',
          label: 'Down Then Right',
          value: null,
          icon: 'down-then-right.svg',
        },
        {
          name: 'down_then_left',
          class: 'down-then-left',
          label: 'Down Then Left',
          value: null,
          icon: 'down-then-left.svg',
        },
        {
          name: 'left_then_up',
          class: 'left-then-up',
          label: 'Left Then Up',
          value: null,
          icon: 'left-then-up.svg',
        },
        {
          name: 'right_then_up',
          class: 'right-then-up',
          label: 'Right Then Up',
          value: null,
          icon: 'right-then-up.svg',
        },
        {
          name: 'left_then_down',
          class: 'left-then-down',
          label: 'Left Then Down',
          value: null,
          icon: 'left-then-down.svg',
        },
        {
          name: 'right_then_down',
          class: 'right-then-down',
          label: 'Right Then Down',
          value: null,
          icon: 'right-then-down.svg',
        },
        // up then down
        {
          name: 'up_then_down',
          class: 'up-then-down',
          label: 'Up Then Down',
          value: null,
          icon: 'up-then-down.svg',
        },
        // down then up
        {
          name: 'down_then_up',
          class: 'down-then-up',
          label: 'Down Then Up',
          value: null,
          icon: 'down-then-up.svg',
        },
        // left then right
        {
          name: 'left_then_right',
          class: 'left-then-right',
          label: 'Left Then Right',
          value: null,
          icon: 'left-then-right.svg',
        },
        // right then left
        {
          name: 'right_then_left',
          class: 'right-then-left',
          label: 'Right Then Left',
          value: null,
          icon: 'right-then-left.svg',
        },
      ],
      commands: [],
      settings: {
        useHotkey: true,
        hotkey: 'Alt',
      },
      hotkeys: [
        {
          value: 'Alt',
          label: 'Alt',
        },
        {
          value: 'Ctrl',
          label: 'Ctrl',
        },
        {
          value: 'Shift',
          label: 'Shift',
        },
      ],
      // svgImageCommands: [],
      windowHeight: 500,
      windowWidth: 500,
      loading: true,
      dialogVisible: false,
      onSetDirection: null,
      refreshCmds: false,
      dialogContextInfo: false,
      dialogRequestCommands: false,
      dialogSettingsVisible: false,
      request: '',
      loading: true,
    }
  },
  watch: {
    search(newValue, oldValue) {
      sketchup.search(newValue)
    },
    focus(newValue, oldValue) {
      // sketchup.mouseFocusChanged(newValue)
    },
  }, 
  methods: {
    activeGestures(){
      // gestures by context
      var gestures = this.gestures[this.activeContextName]
      if (gestures) {
        return gestures['gestures']
      }
      else {
        this.gestures[this.activeContextName] = {};
        this.gestures[this.activeContextName]['gestures'] = {};
        return this.gestures[this.activeContextName]['gestures']
      }
    },
    showContextInfo() {
      this.$alert(`
        <strong>You can set up different mouse gestures for various contexts.</strong>
        <br>
        - You can create different gestures for tool like <strong>Pushpull</strong>, <strong>Scale</strong>, or <strong>Curic Align</strong>,
        <br>
        - As well as for different selection elements like <strong>Dynamic Component</strong> or <strong>Section Plane</strong>
        <br>
        <br>
        <strong>When drawing gesture:</strong>
        <br>
          - Hold <strong>Shift</strong> key  to toggle Global/Active Context.
        <br>
          - Pess <strong>Ctrl/Option</strong> key to set the default context.
        <br>
        `, 'Context feature', {
        dangerouslyUseHTMLString: true
      });

      // this.dialogContextInfo = true;
    },
    handleMenu(command){
      if (command === 'Import'){
        this.loadGestures()
      }
      else if (command === 'Export'){
        this.exportGestures()
      }
      else if (command === 'Remove'){
        this.removeAll()
      }
      else if (command === 'Refresh'){
        this.refresh()
      }
      else if (command === 'Settings'){
        this.dialogSettingsVisible = true;
      }
    },
    addCommand(command){
      // console.log(command, this.onSetDirection)
      this.activeGestures()[this.onSetDirection] = command;
      // console.log('setDirection', this.onSetDirection, command, this.activeContextName)
      sketchup.setDirection(this.onSetDirection, command, this.activeContext);
      this.dialogVisible = false;
      this.search = ''
    },
    setDirection(direction) {
      this.onSetDirection = direction
      this.dialogVisible = true;
      // Select input text
      setTimeout(() => {
        document.querySelector("#inputSearch").focus();
      }, 300);
    },   
    onSetDirectionData() {
      d = this.directions.find(d => d.name == this.onSetDirection)
      if (!d) {
        d = this.two_directions.find(d => d.name == this.onSetDirection)
      }

      return d;
    },  
    removeDirection() {
      this.activeGestures()[this.onSetDirection] = null;
      sketchup.setDirection(this.onSetDirection, null, this.activeContext);
      this.dialogVisible = false;
      this.search = ''
    },
    loadIcon(cmd, e){
      console.log('loadIcon', cmd, e)
      if (cmd && cmd.icon_extname == '.svg'){
        this.svgToPng(cmd, e)
      }
    },
    svgToPng(cmd, e){
      // console.log('svgToPng', cmd, e)

      if (cmd.icon_extname == '.svg') {
        const svgImage = e.target;
        var canvas = document.getElementById("canvas"),
            context = canvas.getContext("2d");
  
        canvas.width = 64;
        canvas.height = 64;
        context.drawImage(svgImage, 0, 0, 64, 64);
  
        const imgData = canvas.toDataURL('image/png');
        // console.log(imgData)
        sketchup.svgToPng(cmd, imgData);
        context.clearRect(0, 0, canvas.width, canvas.height);
      }
    },
    loadGestures(){
      sketchup.loadGestures();
    },
    exportGestures(){
      sketchup.exportGestures(this.gestures);
    },
    layoutUI(){},
    transformIcon( i){
      return `rotate(${i * 45}deg)`
    },
    refresh(){
      sketchup.refresh();
    },     
    refreshCommands(){
      this.refreshCmds = true;
      this.loading = true;
      sketchup.refreshCommands(this.search);
    },      
    sendRequest(){
      this.dialogRequestCommands = false;
      sketchup.sendRequest(this.request);
      this.request = '';
      this.$message({
        message: 'Request sent!',
        type: 'success'
      });
    },  
    removeAll(){
      this.$confirm('Are you sure to remove all gestures?. Continue?', 'Warning', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        type: 'warning'
      }).then(() => {
        sketchup.removeAll(this.activeContextName);
      }).catch(() => {
              //  
      });
    },
    apllySettings(){
      sketchup.applySettings(this.settings);
      this.dialogSettingsVisible = false;
    }
  },
  computed: {
    commandsListHeight(){
      return this.windowHeight - 100 + 'px';
    },
    svgImageCommands(){
      return this.commands.filter(cmd => cmd.icon_extname == '.svg')
    },
    activeContext(){
      return this.contexts.find(c => c.name == this.activeContextName)
    }
  },
  updated: function () {
    this.$nextTick(function () {
      // this.layoutUI();
    })
  },
  mounted: function() {
    this.windowHeight = window.innerHeight;
    this.windowWidth = window.outerWidth;

    setTimeout(() => {
      app.layoutUI();
    }, 300);

    sketchup.ready(window.outerWidth, window.outerHeight);
    sketchup.search(this.search)

    this.$nextTick(() => {
      window.addEventListener("resize", () => {
        app.windowHeight = window.innerHeight;
        app.windowWidth = window.outerWidth;
        app.layoutUI();
      });
    });
  },
})

function updateData(data) {
  app.gestures = data.gestures;
  app.commands = data.commands;
}

function updateCommands(data) {
  app.commands = data.commands;
}

function refreshCommand(cmd) {
  // console.log('refreshCommand', cmd)
  app.commands = app.commands.map(c => {
    if (c.id == cmd.id) {
      return cmd;
    }
    return c;
  })
}

function updateContexts(contexts) {
  console.log('updateContexts', contexts)
  app.contexts = contexts;
}